require 'rubygems'
require 'net/http'
# Helper mixin to convert json to ruby objects
module JsonHelper
  def from_json(json)
      return eval(json.gsub(/(\w*)(\:)\s*([-_'a-z"0-9tfn\[{])/,'\2\1=>\3'))
  end
  def from_json_quoted(json)
      return eval(json.gsub(/(\w*)(\:)\s*([-_'a-z"0-9tfn\[{])/,'"\1"=>\3'))
  end
end
# Lua serializer helper
module LuaHelper
  def ruby_to_lua(v)
    if v=~ /\D+/
      return "\"#{v}\""
    else
      return v
    end
  end
end
# MAth helpers
module Math
  def self.max(a, b)
    a > b ? a : b
  end

  def self.min(a, b)
    a < b ? a : b
  end
end
# Mixings to Array and Hash to serialize to lua
class Array
  include LuaHelper
  include Enumerable
  def to_lua(depth=1)
    result = "{"
    each {|v|
        if v.instance_of? Array
          result << v.to_lua(depth+1)
        elsif v.instance_of? Hash
          result << v.to_lua(depth+1)
        else
          myval = ruby_to_lua(v)
          result << "\"#{myval}\","
        end
      }
    result << "}\n"
    return result
  end
end
class Hash
  include LuaHelper
  include Enumerable
  def to_lua(depth=1)
    # code here to generate lua out
    result = ("\t" * depth) +"{\n"
    keys.each {|k|
      mykey = ruby_to_lua(k)
      myval = fetch(k)
      if mykey.to_s.length <= 0
        next
      end
      if myval.instance_of? Hash
        result << ("\t" * depth) + "[#{mykey}] = \n" + myval.to_lua(depth+1)
      elsif myval.instance_of? Array
        result << ("\t" * depth) + "[#{mykey}] = \n" + myval.to_lua(depth+1)
      else
        myval = ruby_to_lua(myval)
        result << ("\t" * depth)+ "[#{mykey}] = #{myval},\n"
      end
      }
    comma = ""
    if depth > 1
      comma = ","
    end
    return result << ("\t" * depth) + "}#{comma}\n"
  end
end

class Polygon
  class Point
    attr_accessor :x, :y
    def initialize(x,y)
      @x = x
      @y = y
    end
  end
  def initialize()
    @points = Array.new
  end
  def add_point(x,y)
    @points << Point::new(x,y)
  end
  def contains_point(x,y)
    p = Point::new(x,y)
    x1,y1,x2,y2,xold,yold,xnew,ynew = 0
    i = 0
    inside = false
    npoints = @points.length
    if npoints < 3
      return false
    end
    
    xold = @points[npoints-1].x
    yold = @points[npoints-1].y
    while i < npoints
      xnew = @points[i].x
      ynew = @points[i].y
      if xnew > xold
        x1 = xold
        x2 = xnew
        y1 = yold
        y2 = ynew
      else
        x1 = xnew
        x2 = xold
        y1 = ynew
        y2 = yold
      end
      if ( (xnew < p.x) == (p.x <= xold) ) and ( ((p.y-y1)*(x2-x1)) <  ((y2-y1)*(p.x-x1)) )
        if inside
          inside = false
        else
          inside = true
        end
      end
      xold = xnew
      yold = ynew
      # loop increment
      i = i + 1
    end
    return inside
  end
end